-- projekt: sintetizator, DES 2024/25

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity sint25 is
 port (
   clk : in std_logic;	
	data : inout unsigned(7 downto 0); -- IO modul
	addr : out unsigned(1 downto 0); 
	clkout: out std_logic;	
	pwm1 : out std_logic; -- dodaten PWM modul
   led : out unsigned(7 downto 0) );
end sint25;

architecture RTL of sint25 is
 signal clk1 : std_logic;
 signal gen1, gen2, gen3, gen4, zvok : signed(7 downto 0);
 
 signal div : unsigned(7 downto 0) := to_unsigned(0,8); 
 signal zvokn : unsigned(7 downto 0);
 
 signal btn : unsigned(3 downto 0);
 signal korak : unsigned(15 downto 0);
 signal adr : unsigned(1 downto 0);
 signal dout: unsigned(7 downto 0);
 signal pwm : std_logic := '0';
begin

-- deljenje sistemske ure 50 MHz na 100 kHz (clk1)
process(clk)
begin
 if rising_edge(clk) then
  if div = 249 then
     div <= (others=>'0');
	  zvokn <= unsigned(zvok xor "10000000");
	  
     clk1 <= not clk1;
  else
     div <= div + 1;
  end if;
 end if;
end process;

-- generiraj PWM izhod
pwm <= '1' when div < zvokn else '0';
pwm1 <= pwm;

-- IO vmesnik
u0:entity work.IOvmes port map(
   clk=>clk, 
	num=>"0000", 
	din=>data(3 downto 0), 
	addr=>adr,	
	dout=>dout,
	btn=>btn );

data <= dout when adr="10" else 
        "ZZ" & pwm & "ZZZZZ" when adr="11" else
		  "ZZZZZZZZ";		
addr <= adr;	
clkout <= clk;

			
-- generatorji sinusa z nastavljenim korakom

u1: entity work.gen port map(
	clk => clk1,	 
	korak => to_unsigned(1000, 16),
	data => gen1
);

-- TODO: izbiralnik za izhodni zvok

 
end RTL;